Index: /trunk/src/org/expeditee/items/Item.java
===================================================================
--- /trunk/src/org/expeditee/items/Item.java	(revision 1412)
+++ /trunk/src/org/expeditee/items/Item.java	(revision 1413)
@@ -2258,6 +2433,5 @@
 	 *            The new Y coordinate
 	 */
-	public void setPosition(float x, float y)
-	{
+	public void setPosition(float x, float y) {
 		float deltaX = x - _x;
 		float deltaY = y - _y;
@@ -2363,4 +2537,11 @@
 		invalidateCommonTraitForAll(ItemAppearence.PostMoved);
 
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.POSITION_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.POSITION_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.POSITION_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2399,4 +2580,12 @@
 	public final void setThickness(float thick) {
 		setThickness(thick, true);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.THICKNESS_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.THICKNESS_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.THICKNESS_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2451,7 +2640,5 @@
 	 */
 	public float getThickness()	{
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.THICKNESS + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.THICKNESS_STR)) {
 			return this.getClassic().getThickness();
 		} else {
@@ -2505,4 +2692,12 @@
 	public void setX(float newX) {
 		setPosition(newX, getY());
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.POSITION_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.POSITION_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.POSITION_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2515,4 +2710,12 @@
 	public void setY(float newY) {
 		setPosition(getX(), newY);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.POSITION_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.POSITION_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.POSITION_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -3313,6 +3516,5 @@
 	}
 
-	public void setAnchorLeft(Integer anchor)
-	{
+	public void setAnchorLeft(Integer anchor) {
 		this._anchoring.setLeftAnchor(anchor);
 		if (anchor != null) {
@@ -3320,8 +3522,15 @@
 		    setX(anchor);
 		}
-	}
-
-	public void setAnchorRight(Integer anchor)
-	{
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_LEFT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_LEFT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_LEFT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
+	}
+
+	public void setAnchorRight(Integer anchor) {
 		this._anchoring.setRightAnchor(anchor);
 		if (anchor != null) {
@@ -3329,8 +3538,15 @@
 			setX(DisplayController.getFramePaintArea().getMaxX() - anchor - getBoundsWidth());
 		}
-	}
-
-	public void setAnchorTop(Integer anchor)
-	{
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_RIGHT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_RIGHT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_RIGHT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
+	}
+
+	public void setAnchorTop(Integer anchor) {
 		this._anchoring.setTopAnchor(anchor);
 		if (anchor != null) {
@@ -3338,9 +3554,16 @@
 			setY(anchor);
 		}
-	}
-
-
-	public void setAnchorBottom(Integer anchor)
-	{
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_TOP_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_TOP_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_TOP_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
+	}
+
+
+	public void setAnchorBottom(Integer anchor) {
 		this._anchoring.setBottomAnchor(anchor);
 		if (anchor != null) {
@@ -3348,4 +3571,12 @@
 			setY(DisplayController.getFramePaintArea().getMaxY() - anchor);
 		}
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_BOTTOM_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_BOTTOM_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_BOTTOM_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -3364,7 +3595,5 @@
 
 	public Integer getAnchorLeft() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ANCHOR_LEFT + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ANCHOR_LEFT_STR)) {
 			return this.getClassic().getAnchorLeft();
 		} else {
@@ -3374,7 +3603,5 @@
 
 	public Integer getAnchorRight() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ANCHOR_RIGHT + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ANCHOR_RIGHT_STR)) {
 			return this.getClassic().getAnchorRight();
 		} else {
@@ -3384,7 +3611,5 @@
 
 	public Integer getAnchorTop() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ANCHOR_TOP + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ANCHOR_TOP_STR)) {
 			return this.getClassic().getAnchorTop();
 		} else {
@@ -3394,7 +3619,5 @@
 
 	public Integer getAnchorBottom() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ANCHOR_BOTTOM + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ANCHOR_BOTTOM_STR)) {
 			return this.getClassic().getAnchorBottom();
 		} else {
@@ -3404,7 +3627,5 @@
 
 	public String getText() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.TEXT + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.TEXT_STR)) {
 			return this.getClassic().getText();
 		} else {
@@ -3646,7 +3867,5 @@
 	
 	public int getMagnetizedItemLeft() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.MAGNETIZED_ITEM_LEFT + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.MAGNETIZED_ITEM_LEFT_STR)) {
 			return this.getClassic().getMagnetizedItemLeft();
 		} else {
@@ -3662,10 +3881,16 @@
 	public void setMagnetizedItemLeft(final int id) {
 		setMagnetizedItemLeft(this.getParent().getItemWithID(id));
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.MAGNETIZED_ITEM_LEFT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MAGNETIZED_ITEM_LEFT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.MAGNETIZED_ITEM_LEFT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public int getMagnetizedItemRight() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.MAGNETIZED_ITEM_RIGHT + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.MAGNETIZED_ITEM_RIGHT_STR)) {
 			return this.getClassic().getMagnetizedItemRight();
 		} else {
@@ -3681,10 +3906,16 @@
 	public void setMagnetizedItemRight(final int id) {
 		setMagnetizedItemRight(this.getParent().getItemWithID(id));
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.MAGNETIZED_ITEM_RIGHT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MAGNETIZED_ITEM_RIGHT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.MAGNETIZED_ITEM_RIGHT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public int getMagnetizedItemTop() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.MAGNETIZED_ITEM_TOP + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.MAGNETIZED_ITEM_TOP_STR)) {
 			return this.getClassic().getMagnetizedItemTop();
 		} else {
@@ -3700,10 +3931,16 @@
 	public void setMagnetizedItemTop(final int id) {
 		setMagnetizedItemTop(this.getParent().getItemWithID(id));
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.MAGNETIZED_ITEM_TOP_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MAGNETIZED_ITEM_TOP_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.MAGNETIZED_ITEM_TOP_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public int getMagnetizedItemBottom() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.MAGNETIZED_ITEM_BOTTOM + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.MAGNETIZED_ITEM_BOTTOM_STR)) {
 			return this.getClassic().getMagnetizedItemBottom();
 		} else {
@@ -3719,10 +3956,16 @@
 	public void setMagnetizedItemBottom(final int id) {
 		setMagnetizedItemBottom(this.getParent().getItemWithID(id));
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.MAGNETIZED_ITEM_BOTTOM_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MAGNETIZED_ITEM_BOTTOM_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.MAGNETIZED_ITEM_BOTTOM_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public String getEncryptionLabel() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.ENCRYPTION_LABEL + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.ENCRYPTION_LABEL_STR)) {
 			return this.getClassic().getEncryptionLabel();
 		} else {
@@ -3734,13 +3977,24 @@
 		this._encryptionLabel = label;
 		if (this.getSurrogates().isEmpty()) {
-			Surrogate surrogate = Surrogate.forItem(this);
-			this.addToSurrogates(surrogate);
-		}
+			Item copy = this.copy();
+			if (copy instanceof Text) {	copy.setText("Encrypted"); }
+			this.addToSurrogates(copy);
+		}
+		
+		
 		
 		for (Character tag: DefaultFrameWriter.getItemTags().keySet()) {
 			if (tag == 'S') {
-				propertyEncryption.put(tag + "", EncryptionDetail.UnencryptedOnSave);
+				classicPropertyEncryption.put(tag + "", EncryptionDetail.UnencryptedOnSave);
 			} else {
-				propertyEncryption.put(tag + "", EncryptionDetail.ReencryptOnSave);
+				classicPropertyEncryption.put(tag + "", EncryptionDetail.ReencryptOnSave);
+			}
+			
+			for (Item surrogate: this.getSurrogates()) {
+				if (tag == 'T') {
+					surrogate.surrogatePropertyInheritance.put(tag + "", false);
+				} else {
+					surrogate.surrogatePropertyInheritance.put(tag + "", true);
+				}
 			}
 		}
@@ -3748,9 +4002,21 @@
 		for (String tag: DefaultFrameWriter.getItemTagsExt().keySet()) {
 			if (tag == "_el") {
-				propertyEncryption.put(tag, EncryptionDetail.UnencryptedOnSave);
+				classicPropertyEncryption.put(tag, EncryptionDetail.UnencryptedOnSave);
 			} else {
-				propertyEncryption.put(tag, EncryptionDetail.ReencryptOnSave);
-			}
-		}
+				classicPropertyEncryption.put(tag, EncryptionDetail.ReencryptOnSave);
+			}
+			
+			for (Item surrogate: this.getSurrogates()) {
+				surrogate.surrogatePropertyInheritance.put(tag + "", true);
+			}
+		}
+		
+/*		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ENCRYPTION_LABEL_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ENCRYPTION_LABEL_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ENCRYPTION_LABEL_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}*/
 	}
 	
@@ -3760,7 +4026,7 @@
 		for (Character tag: DefaultFrameWriter.getItemTags().keySet()) {
 			if (tag == 'S') {
-				propertyEncryption.put(tag + "", EncryptionDetail.UnencryptedOnSave);
+				classicPropertyEncryption.put(tag + "", EncryptionDetail.UnencryptedOnSave);
 			} else {
-				propertyEncryption.put(tag + "", EncryptionDetail.ReencryptOnSave);
+				classicPropertyEncryption.put(tag + "", EncryptionDetail.ReencryptOnSave);
 			}
 		}
@@ -3768,7 +4034,7 @@
 		for (String tag: DefaultFrameWriter.getItemTagsExt().keySet()) {
 			if (tag == "_el") {
-				propertyEncryption.put(tag, EncryptionDetail.UnencryptedOnSave);
+				classicPropertyEncryption.put(tag, EncryptionDetail.UnencryptedOnSave);
 			} else {
-				propertyEncryption.put(tag, EncryptionDetail.ReencryptOnSave);
+				classicPropertyEncryption.put(tag, EncryptionDetail.ReencryptOnSave);
 			}
 		}
@@ -3826,14 +4092,15 @@
 	}
 
-	public Set<Surrogate> getSurrogates() {
+	public Set<Item> getSurrogates() {
 		return surrogateItems;
 	}
 		
-	public void setAsSurrogateFor(Item classic) {
+	private void setAsSurrogateFor(Item classic) {
 		this.surrogateFor = classic;
 	}
 
-	public void addToSurrogates(Surrogate surrogate) {
+	public void addToSurrogates(Item surrogate) {
 		this.surrogateItems.add(surrogate);
+		surrogate.setAsSurrogateFor(this);
 	}
 	
@@ -3847,5 +4114,5 @@
 	
 	public EncryptionDetail getEncryptionDetailForTag(String tag) {
-		EncryptionDetail encryptionDetail = propertyEncryption.get(tag);
+		EncryptionDetail encryptionDetail = classicPropertyEncryption.get(tag);
 		
 		if (encryptionDetail == null) {
@@ -3857,5 +4124,20 @@
 	
 	public void setEncryptionDetailForTag(String tag, EncryptionDetail encryptionDetail) {
-		propertyEncryption.put(tag, encryptionDetail);
+		classicPropertyEncryption.put(tag, encryptionDetail);
+	}
+	
+	public boolean isTagInherited(String tag) {
+		return surrogatePropertyInheritance.get(tag);
+	}
+	
+
+	/**
+	 * If when setting a property, we find that the classic has a undeciphered value, when we must containue using that undeciphered value
+	 * when eventually saving.
+	 * @return
+	 */
+	protected boolean subjectToInheritanceCheckOnSave(String tag) {
+		if (getClassic() == null) return false;
+		return getClassic().classicPropertyEncryption.get(tag) != EncryptionDetail.UseUndecipheredValueOnSave;
 	}
 }
Index: /trunk/src/org/expeditee/items/Text.java
===================================================================
--- /trunk/src/org/expeditee/items/Text.java	(revision 1412)
+++ /trunk/src/org/expeditee/items/Text.java	(revision 1413)
@@ -41,5 +41,5 @@
 import org.expeditee.core.bounds.AxisAlignedBoxBounds;
 import org.expeditee.core.bounds.PolygonBounds;
-import org.expeditee.encryption.items.surrogates.Surrogate;
+import org.expeditee.encryption.items.surrogates.EncryptionDetail;
 import org.expeditee.gio.EcosystemManager;
 import org.expeditee.gio.GraphicsManager;
@@ -404,4 +404,12 @@
 		rebuild(true);
 		invalidateAll();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.WIDTH_TO_SAVE_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.WIDTH_TO_SAVE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.WIDTH_TO_SAVE_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -419,4 +427,12 @@
 		rebuild(true);
 		invalidateAll();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -434,9 +450,9 @@
 	@Override
 	public Integer getWidth() {
-		if (_width == null || _width <= 0) {
-			return null;
-		}
-
-		return _width;
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.WIDTH_TO_SAVE_STR)) {
+			return this.getClassic().getWidth();
+		} else {
+			return _width;
+		}
 	}
 
@@ -450,8 +466,9 @@
 
 	public Integer getMinWidth() {
-		if (_minWidth == null || _minWidth <= 0) {
-			return null;
-		}
-		return _minWidth;
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.MIN_WIDTH_TO_SAVE_STR)) {
+			return this.getClassic().getMinWidth();
+		} else {
+			return _minWidth;
+		}
 	}
 
@@ -465,8 +482,9 @@
 	@Override
 	public Colour getHighlightColor() {
-		if (_highlightColour.equals(getPaintBackgroundColor())) {
-			return ALTERNATE_HIGHLIGHT;
-		}
-		return _highlightColour;
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.HIGHLIGHT_STR)) {
+			return this.getClassic().getHighlightColor();
+		} else {
+			return _highlightColour;
+		}
 	}
 
@@ -490,4 +508,12 @@
 		rebuild(true);
 		invalidateAll();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.JUSTIFICATION_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.JUSTIFICATION_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.JUSTIFICATION_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -501,7 +527,5 @@
 	 */
 	public Justification getJustification() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.JUSTIFICATION + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.JUSTIFICATION_STR)) {
 			return ((Text) this.getClassic()).getJustification();
 		} else {
@@ -665,4 +689,12 @@
 
 		rebuild(true);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.TEXT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.TEXT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.TEXT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1295,4 +1327,12 @@
 
 		invalidateAll();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.FONT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.FONT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.FONT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1303,7 +1343,5 @@
 	 */
 	public Font getFont() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.FONT + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.FONT_STR)) {
 			return ((Text) this.getClassic()).getFont();
 		} else {
@@ -1469,5 +1507,9 @@
 	@Override
 	public String getText() {
-		return _text.toString();
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.TEXT_STR)) {
+			return this.getClassic().getText();
+		} else {
+			return _text.toString();
+		}
 	}
 
@@ -1507,4 +1549,12 @@
 		_spacing = spacing;
 		invalidateBounds();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.SPACING_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.SPACING_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1515,7 +1565,5 @@
 	 */
 	public float getSpacing() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.SPACING + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.SPACING_STR)) {
 			return ((Text) this.getClassic()).getSpacing();
 		} else {
@@ -1542,10 +1590,16 @@
 	public void setWordSpacing(int spacing) {
 		_word_spacing = spacing;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.WORD_SPACING_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.WORD_SPACING_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.WORD_SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public int getWordSpacing() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.WORD_SPACING + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.WORD_SPACING_STR)) {
 			return ((Text) this.getClassic()).getWordSpacing();
 		} else {
@@ -1567,4 +1621,12 @@
 		currentFont.setSpacing(spacing);
 		// setFont(currentFont);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.LETTER_SPACING_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.LETTER_SPACING_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.LETTER_SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -1574,7 +1636,5 @@
 	 */
 	public float getLetterSpacing() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.LETTER_SPACING + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.LETTER_SPACING_STR)) {
 			return ((Text) this.getClassic()).getLetterSpacing();
 		} else {
@@ -1585,10 +1645,16 @@
 	public void setInitialSpacing(float spacing) {
 		_initial_spacing = spacing;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.INITIAL_SPACING_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.INITIAL_SPACING_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.INITIAL_SPACING_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
 	public float getInitialSpacing() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.INITIAL_SPACING + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.INITIAL_SPACING_STR)) {
 			return ((Text) this.getClassic()).getInitialSpacing();
 		} else {
@@ -2795,4 +2861,12 @@
 		invalidateCommonTrait(ItemAppearence.PostMoved);
 		invalidateFill();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_LEFT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_LEFT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_LEFT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2821,4 +2895,12 @@
 		invalidateCommonTrait(ItemAppearence.PostMoved);
 		invalidateFill();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_RIGHT_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_RIGHT_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_RIGHT_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2854,4 +2936,12 @@
 		invalidateCommonTrait(ItemAppearence.PostMoved);
 		invalidateFill();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_TOP_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_TOP_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_TOP_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -2892,4 +2982,12 @@
 		invalidateCommonTrait(ItemAppearence.PostMoved);
 		invalidateFill();
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.ANCHOR_BOTTOM_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.ANCHOR_BOTTOM_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.ANCHOR_BOTTOM_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -3047,7 +3145,5 @@
 
 	public boolean getAutoWrap() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.AUTO_WRAP_TO_SAVE + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.AUTO_WRAP_TO_SAVE_STR)) {
 			return ((Text) this.getClassic()).getAutoWrap();
 		} else {
@@ -3059,5 +3155,5 @@
 	// normally
 	public String getAutoWrapToSave() {
-		if (!_autoWrap) {
+		if (!getAutoWrap()) {
 			return null;
 		}
@@ -3067,4 +3163,12 @@
 	public void setAutoWrap(boolean autoWrap) {
 		_autoWrap = autoWrap;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.AUTO_WRAP_TO_SAVE_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.AUTO_WRAP_TO_SAVE_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.AUTO_WRAP_TO_SAVE_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -3189,26 +3293,25 @@
 
 	public Integer getMask() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.MASK + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.MASK_STR)) {
 			return ((Text) this.getClassic()).getMask();
 		} else {
-			if (_mask == null) {
-				return null;
-			} else {
-				return _mask;
-			}
-		}
-
+			return _mask;
+		}
 	}
 
 	public void setMask(final Integer c) {
 		_mask = c;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.MASK_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.MASK_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.MASK_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public String getPlaceholder() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.PLACEHOLDER + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.PLACEHOLDER_STR)) {
 			return ((Text) this.getClassic()).getPlaceholder();
 		} else {
@@ -3222,4 +3325,12 @@
 	public void setPlaceholder(String _placeholder) {
 		this._placeholder = new StringBuffer(_placeholder);
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.PLACEHOLDER_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.PLACEHOLDER_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.PLACEHOLDER_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 
@@ -3235,7 +3346,5 @@
 
 	public boolean isSingleLineOnly() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.SINGLE_LINE_ONLY + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.SINGLE_LINE_ONLY_STR)) {
 			return ((Text) this.getClassic()).isSingleLineOnly();
 		} else {
@@ -3246,10 +3355,16 @@
 	public void setSingleLineOnly(boolean _singleLine) {
 		this._singleLine = _singleLine;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.SINGLE_LINE_ONLY_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.SINGLE_LINE_ONLY_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
 	public int getTabIndex() {
-		Surrogate surrogate = Surrogate.of(this);
-		if (surrogate != null && 
-				surrogate.isPropertyIsInherited(DefaultFrameWriter.TAB_INDEX + "")) {
+		if (isSurrogate() && surrogatePropertyInheritance.get(DefaultFrameWriter.TAB_INDEX_STR)) {
 			return ((Text) this.getClassic()).getTabIndex();
 		} else {
@@ -3260,4 +3375,12 @@
 	public void setTabIndex(int index) {
 		this._tabIndex = index;
+		
+		if (isSurrogate()) {
+			surrogatePropertyInheritance.put(DefaultFrameWriter.TAB_INDEX_STR, false);
+			Item classic = getClassic();
+			if (subjectToInheritanceCheckOnSave(DefaultFrameWriter.TAB_INDEX_STR)) {
+				classic.classicPropertyEncryption.put(DefaultFrameWriter.TAB_INDEX_STR, EncryptionDetail.InheritanceCheckOnSave);
+			}
+		}
 	}
 	
